## mysql-cluster-community 8.0.19

=== storage/ndb/ndbapi-examples/CMakeLists.txt ===
# Copyright (c) 2014, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

# Disable specific types of warnings for current directory
# if the compiler supports the flag
FOREACH(warning
    "unused-but-set-variable"
    "strict-aliasing"
    "unused-parameter"
    # Downgrade -Werror to warning for "may be used uninitialized"
    "error=maybe-uninitialized"
    )
  MY_CHECK_CXX_COMPILER_WARNING("${warning}" HAS_WARN_FLAG)
  IF(HAS_WARN_FLAG)
    STRING_APPEND(CMAKE_CXX_FLAGS " ${HAS_WARN_FLAG}")
    STRING_APPEND(CMAKE_C_FLAGS " ${HAS_WARN_FLAG}")
  ENDIF()
ENDFOREACH()

# NdbApi examples
ADD_EXECUTABLE(ndb_ndbapi_array_simple
  ndbapi_array_simple/ndbapi_array_simple.cpp)
ADD_EXECUTABLE(ndb_ndbapi_array_using_adapter
  ndbapi_array_using_adapter/ndbapi_array_using_adapter.cpp)
ADD_EXECUTABLE(ndb_ndbapi_async ndbapi_async/ndbapi_async.cpp)
ADD_EXECUTABLE(ndb_ndbapi_async1 ndbapi_async1/ndbapi_async1.cpp)
ADD_EXECUTABLE(ndb_ndbapi_blob ndbapi_blob/ndbapi_blob.cpp)
ADD_EXECUTABLE(ndb_ndbapi_blob_ndbrecord ndbapi_blob_ndbrecord/main.cpp)
ADD_EXECUTABLE(ndb_ndbapi_event ndbapi_event/ndbapi_event.cpp)
ADD_EXECUTABLE(ndb_ndbapi_recattr_vs_record ndbapi_recattr_vs_record/main.cpp)
ADD_EXECUTABLE(ndb_ndbapi_retries ndbapi_retries/ndbapi_retries.cpp)
ADD_EXECUTABLE(ndb_ndbapi_scan ndbapi_scan/ndbapi_scan.cpp)
ADD_EXECUTABLE(ndb_ndbapi_simple ndbapi_simple/ndbapi_simple.cpp)
ADD_EXECUTABLE(ndb_ndbapi_simple_dual ndbapi_simple_dual/main.cpp)
ADD_EXECUTABLE(ndb_ndbapi_simple_index ndbapi_simple_index/main.cpp)
ADD_EXECUTABLE(ndb_ndbapi_s_i_ndbrecord ndbapi_s_i_ndbrecord/main.cpp)

# MgmApi examples
ADD_EXECUTABLE(ndb_mgmapi_logevent mgmapi_logevent/main.cpp)
ADD_EXECUTABLE(ndb_mgmapi_logevent2 mgmapi_logevent2/main.cpp)

# Link each example program with both ndbclient and mysql libraries
SET(EXAMPLES
  ndb_ndbapi_array_simple
  ndb_ndbapi_array_using_adapter
  ndb_ndbapi_async
  ndb_ndbapi_async1
  ndb_ndbapi_blob
  ndb_ndbapi_blob_ndbrecord
  ndb_ndbapi_event
  ndb_ndbapi_recattr_vs_record
  ndb_ndbapi_retries
  ndb_ndbapi_scan
  ndb_ndbapi_simple
  ndb_ndbapi_simple_dual
  ndb_ndbapi_simple_index
  ndb_ndbapi_s_i_ndbrecord
  ndb_mgmapi_logevent
  ndb_mgmapi_logevent2
)
FOREACH(EXAMPLE ${EXAMPLES})
  SET_TARGET_PROPERTIES(${EXAMPLE} PROPERTIES ENABLE_EXPORTS TRUE)
  TARGET_LINK_LIBRARIES(${EXAMPLE} libmysql)
  TARGET_LINK_LIBRARIES(${EXAMPLE} ndbclient_so)
ENDFOREACH()

=== storage/ndb/src/CMakeLists.txt ===
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

INCLUDE(libutils)

# Disable specific types of warnings for current directory
# if the compiler supports the flag
FOREACH(warning
    "unused-but-set-variable"
    "strict-aliasing"
    "unused-parameter"
    "cast-qual"
    # Downgrade -Werror to warning for "may be used uninitialized"
    "error=maybe-uninitialized"
    # Downgrade placement-new as part of Bug #24822203
    "error=placement-new"
    # Downgrade -Werror=deprecated-copy to warning for gcc 9
    "error=deprecated-copy"
    # Downgrade -Werror=stringop-truncation to warning for gcc 8/9
    "error=stringop-truncation"
    )
  MY_CHECK_CXX_COMPILER_WARNING("${warning}" HAS_WARN_FLAG)
  IF(HAS_WARN_FLAG)
    STRING_APPEND(CMAKE_CXX_FLAGS " ${HAS_WARN_FLAG}")
    STRING_APPEND(CMAKE_C_FLAGS " ${HAS_WARN_FLAG}")
  ENDIF()
ENDFOREACH()

##################
# Temporary C++ 8 workarounds:
# (not supported for C, so only set CXX_FLAGS)
FOREACH(warning
    # Workaround for bug#28387760, also failed other places then in NdbEvent*
    "class-memaccess"
    )
  MY_CHECK_CXX_COMPILER_WARNING("${warning}" HAS_WARN_FLAG)
  IF(HAS_WARN_FLAG)
    STRING_APPEND(CMAKE_CXX_FLAGS " ${HAS_WARN_FLAG}")
  ENDIF()
ENDFOREACH()

ADD_SUBDIRECTORY(common)
ADD_SUBDIRECTORY(mgmapi)
ADD_SUBDIRECTORY(ndbapi)

IF(NOT WITHOUT_SERVER)
  ADD_SUBDIRECTORY(kernel)
ENDIF()
ADD_SUBDIRECTORY(mgmclient)
ADD_SUBDIRECTORY(mgmsrv)

IF(BUILD_IS_SINGLE_CONFIG)
  SET(JAVA_SUBDIR)
ELSE()
  set(JAVA_SUBDIR
  $<$<CONFIG:Debug>:Debug>$<$<CONFIG:RelWithDebInfo>:RelWithDebInfo>)
ENDIF()

IF(WIN32)
  SET(JAVA_SEPERATOR ";")
ELSE()
  set(JAVA_SEPERATOR :)
ENDIF()

SET(NDBJTIE_LIB)
IF(HAVE_JDK)
  ADD_SUBDIRECTORY(ndbjtie)
  SET(NDBJTIE_LIB ndbjtie)
  ADD_DEFINITIONS(-DNDB_WITH_NDBJTIE)
ENDIF()

#
# Build static ndbclient library
#
SET(NDBCLIENT_LIBS
  mysys strings
  ${SSL_LIBRARIES} ${ZLIB_LIBRARY}
  ndbapi
  ndbtransport
  ndbtrace
  ndbsignaldata
  ndbmgmapi
  ndbmgmcommon
  ndblogger
  ndbportlib
  ndbgeneral
  ndbconf)

SET(LIBS_TO_MERGE
  mysys
  mytime
  ndbapi
  ndbconf
  ndbgeneral
  ndblogger
  ndbmgmapi
  ndbmgmcommon
  ndbportlib
  ndbsignaldata
  ndbtrace
  ndbtransport
  strings
  )

IF(WITH_ZLIB STREQUAL "bundled")
  LIST(APPEND LIBS_TO_MERGE ${ZLIB_LIBRARY})
ENDIF()


MESSAGE(STATUS "LIBS_TO_MERGE ${LIBS_TO_MERGE}")
MESSAGE(STATUS "NDBCLIENT_LIBS ${NDBCLIENT_LIBS}")

MERGE_CONVENIENCE_LIBRARIES(
  ndbclient_static ${LIBS_TO_MERGE} COMPONENT Development)
TARGET_LINK_LIBRARIES(ndbclient_static PRIVATE ${SSL_LIBRARIES})

# Build test program to check linking against ndclient_static
ADD_EXECUTABLE(ndbclient_static_link_test ndbclient_link_test.cpp)
SET_TARGET_PROPERTIES(ndbclient_static_link_test PROPERTIES ENABLE_EXPORTS TRUE)
TARGET_LINK_LIBRARIES(ndbclient_static_link_test ndbclient_static)

#
# Build shared ndbclient library
#
SET(NDBCLIENT_SO_LIBS ${LIBS_TO_MERGE} ${NDBJTIE_LIB})
SET(NDB_SHARED_LIB_VERSION "6.1.0")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libndbclient.ver.in
               ${CMAKE_CURRENT_BINARY_DIR}/libndbclient.ver)

ADD_LIBRARY(ndbclient_so SHARED ndbclient_exports.cpp)

# Collect all dynamic libraries in the same directory
SET_TARGET_PROPERTIES(ndbclient_so PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/library_output_directory)

ADD_INSTALL_RPATH_FOR_OPENSSL(ndbclient_so)

IF(WIN32_CLANG AND WITH_ASAN)
  TARGET_LINK_LIBRARIES(ndbclient_so
    "${ASAN_LIB_DIR}/clang_rt.asan_dll_thunk-x86_64.lib")
ENDIF()

IF(WIN32)
  # This must be a cmake bug on windows ...
  # Anyways, with this the .dll ends up in the desired directory.
  SET_TARGET_PROPERTIES(ndbclient_so PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/library_output_directory)
ENDIF()

TARGET_LINK_LIBRARIES(ndbclient_so ${NDBCLIENT_SO_LIBS})

IF(APPLE AND HAVE_CRYPTO_DYLIB AND HAVE_OPENSSL_DYLIB)
  ADD_CUSTOM_COMMAND(TARGET ndbclient_so POST_BUILD
    COMMAND install_name_tool -change
    "${CRYPTO_VERSION}" "@loader_path/${CRYPTO_VERSION}"
    $<TARGET_SONAME_FILE:ndbclient_so>
    COMMAND install_name_tool -change
    "${OPENSSL_VERSION}" "@loader_path/${OPENSSL_VERSION}"
    $<TARGET_SONAME_FILE:ndbclient_so>
    )
  # All executables have dependencies:  "@loader_path/../lib/xxx.dylib
  # Create a symlink so that this works for Xcode also.
  IF(NOT BUILD_IS_SINGLE_CONFIG)
    ADD_CUSTOM_COMMAND(TARGET ndbclient_so POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E create_symlink
      $<TARGET_SONAME_FILE_DIR:ndbclient_so> lib
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/runtime_output_directory
      )
  ENDIF()
ENDIF()


IF(APPLE)
  SET_TARGET_PROPERTIES(ndbclient_so PROPERTIES
    MACOSX_RPATH ON
  )
ENDIF()

IF(MSVC)
# All "convenience" libraries are now well-known, we *could* do this:
#  SET(_PLATFORM  x64)
#
#  ADD_CUSTOM_COMMAND(TARGET ndbclient_so PRE_LINK
#    COMMAND cscript ARGS //nologo ${PROJECT_SOURCE_DIR}/win/create_def_file.js
#                         ${_PLATFORM}
#                         "$<TARGET_FILE:lib1>"
#                         "$<TARGET_FILE:lib2>"
#                         ...
#                         > ndbclient_exports.def
#    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
#
#  # Modify link flags to use the generated module definition file
#  GET_TARGET_PROPERTY(ndbclient_so_link_flags ndbclient_so LINK_FLAGS)
#  SET_TARGET_PROPERTIES(ndbclient_so PROPERTIES LINK_FLAGS
#                        "${ndbclient_link_flags} /DEF:ndbclient_exports.def")
ELSE()
  # Turn off cmake's transitive link behaviour so that the shared
  # ndbclient library contains everything except functions from
  # system libs
  SET(NDBCLIENT_SYSTEM_LIBS)
  FOREACH(lib ${NDBCLIENT_SO_LIBS})
    SET(deps ${${lib}_LIB_DEPENDS})
    FOREACH(dep_lib ${deps})
    SET(ignore_dep_lib)

      # The list of dependent libs contains keywords used for debug vs optimized
      # builds, ignore them
      IF(dep_lib MATCHES "general" OR
         dep_lib MATCHES "debug" OR
         dep_lib MATCHES "optimized")
        # MESSAGE(STATUS "Ignoring keyword ${dep_lib}")
        SET(ignore_dep_lib 1)
      ENDIF()

      # Ignore libs where location is known(this means it's built locally)
      LIST(FIND KNOWN_CONVENIENCE_LIBRARIES ${dep_lib} FOUNDIT)
      IF(FOUNDIT GREATER -1)
        # MESSAGE(STATUS "Ignoring ${dep_lib} since location is known")
        SET(ignore_dep_lib 1)
      ENDIF()

      IF(NOT ignore_dep_lib)
        LIST(APPEND NDBCLIENT_SYSTEM_LIBS ${dep_lib})
      ENDIF()

    ENDFOREACH()
  ENDFOREACH()
  IF(NDBCLIENT_SYSTEM_LIBS)
    LIST(REMOVE_DUPLICATES NDBCLIENT_SYSTEM_LIBS)
    MESSAGE(STATUS "System libs used by ndbclient_so: ${NDBCLIENT_SYSTEM_LIBS}")
    TARGET_LINK_LIBRARIES(ndbclient_so LINK_INTERFACE_LIBRARIES
      ${NDBCLIENT_SYSTEM_LIBS})
  ELSE()
    MESSAGE(STATUS "System libs used by ndbclient_so: [none]")
  ENDIF()

  # Prepend any special linker flags(like -m64) for shared library
  GET_TARGET_PROPERTY(ndbclient_so_link_flags ndbclient_so LINK_FLAGS)
  IF(NOT ndbclient_so_link_flags)
    # Avoid LINK_FLAGS-NOTFOUND
    SET(ndbclient_so_link_flags)
  ENDIF()
  SET(ndbclient_so_link_flags
    "${CMAKE_SHARED_LIBRARY_C_FLAGS} ${ndbclient_so_link_flags}")
  IF(LINK_FLAG_NO_UNDEFINED)
    STRING_APPEND(ndbclient_so_link_flags " ${LINK_FLAG_NO_UNDEFINED}")
    STRING_APPEND(ndbclient_so_link_flags
      " -Wl,--version-script=${CMAKE_CURRENT_BINARY_DIR}/libndbclient.ver")
  ENDIF()
  IF(SOLARIS)
    STRING_APPEND(ndbclient_so_link_flags " ${CMAKE_CXX_LINK_FLAGS}")
  ENDIF()
  SET_TARGET_PROPERTIES(ndbclient_so
    PROPERTIES LINK_FLAGS "${ndbclient_so_link_flags}")
ENDIF()


SET_TARGET_PROPERTIES(ndbclient_so PROPERTIES
  OUTPUT_NAME "ndbclient"
  SOVERSION ${NDB_SHARED_LIB_VERSION})
MYSQL_INSTALL_TARGETS(ndbclient_so
  DESTINATION "${INSTALL_LIBDIR}"
  COMPONENT Development)
# Build test program to check linking against ndclient_so
ADD_EXECUTABLE(ndbclient_shared_link_test ndbclient_link_test.cpp)
SET_TARGET_PROPERTIES(ndbclient_shared_link_test PROPERTIES ENABLE_EXPORTS TRUE)
TARGET_LINK_LIBRARIES(ndbclient_shared_link_test ndbclient_so)

=== storage/ndb/test/CMakeLists.txt ===
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

# Disable specific types of warnings for current directory
# if the compiler supports the flag
IF(MY_COMPILER_IS_GNU_OR_CLANG)
  INCLUDE(CheckCXXCompilerFlag)
  FOREACH(warning
          "unused-but-set-variable"
          "strict-aliasing"
          "unused-parameter"
          "cast-qual"
          # Downgrade -Werror=deprecated-copy to warning for gcc 9
          "error=deprecated-copy"
          # Downgrade -Werror to warning for "may be used uninitialized"
          # and "is used uninitialized in this function"
          "error=maybe-uninitialized")
    STRING(REPLACE "-" "_" warning_ ${warning})
    STRING(TOUPPER ${warning_} WARNING)
    CHECK_CXX_COMPILER_FLAG("-W${warning}" HAVE_${WARNING})
    IF(HAVE_${WARNING})
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-${warning}")
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-${warning}")
    ENDIF()
  ENDFOREACH()
ENDIF()

ADD_SUBDIRECTORY(src)
IF(WITH_NDB_TEST)
  ADD_SUBDIRECTORY(tools)
  ADD_SUBDIRECTORY(ndbapi)
  ADD_SUBDIRECTORY(run-test)
ENDIF(WITH_NDB_TEST)

=== storage/ndb/tools/CMakeLists.txt ===
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

# Disable specific types of warnings for current directory
# if the compiler supports the flag
FOREACH(warning
    "unused-but-set-variable"
    "strict-aliasing"
    "unused-parameter"
    "cast-qual"
    # Downgrade -Werror to warning for "may be used uninitialized"
    # and "is used uninitialized in this function"
    "error=maybe-uninitialized"
    # Downgrade -Werror=deprecated-copy to warning for gcc 9
    "error=deprecated-copy"
    # Downgrade -Werror=stringop-truncation to warning for gcc 8/9
    "error=stringop-truncation"
    )
  MY_CHECK_CXX_COMPILER_WARNING("${warning}" HAS_WARN_FLAG)
  IF(HAS_WARN_FLAG)
    STRING_APPEND(CMAKE_CXX_FLAGS " ${HAS_WARN_FLAG}")
    STRING_APPEND(CMAKE_C_FLAGS " ${HAS_WARN_FLAG}")
  ENDIF()
ENDFOREACH()

INCLUDE(${CMAKE_SOURCE_DIR}/storage/ndb/config/type_ndbapitools.cmake)
# Check BISON_VERSION and set BISON_FLAGS_WARNINGS
FIND_PACKAGE(BISON REQUIRED)
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/bison.cmake)

INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/storage/ndb/src/ndbapi
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/kernel/signaldata
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/util
  ${CMAKE_BINARY_DIR}/storage/ndb/tools)

ADD_LIBRARY(ndbtools STATIC
  NdbImport.cpp
  NdbImportImpl.cpp
  NdbImportCsv.cpp
  NdbImportCsvGram.cpp
  NdbImportUtil.cpp)

IF(MY_COMPILER_IS_GNU_OR_CLANG)
  # Suppress warnings for undefined identifiers in bison output
  ADD_COMPILE_FLAGS(${CMAKE_CURRENT_BINARY_DIR}/NdbImportCsvGram.cpp
    COMPILE_FLAGS "-Wno-undef")
ENDIF()

BISON_TARGET(ndb_import
  NdbImportCsvGram.ypp
  ${CMAKE_CURRENT_BINARY_DIR}/NdbImportCsvGram.cpp
  COMPILE_FLAGS "--name-prefix=NdbImportCsv_yy --yacc ${BISON_FLAGS_WARNINGS}"
  DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/NdbImportCsvGram.hpp
  )

# Add target, for easier debugging.
ADD_CUSTOM_TARGET(GenBison_ndb_import DEPENDS ${BISON_ndb_import_OUTPUTS})

MYSQL_ADD_EXECUTABLE(ndb_waiter
  waiter.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_drop_table
  drop_tab.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_delete_all
  delete_all.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static
  )
MYSQL_ADD_EXECUTABLE(ndb_desc
  desc.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_drop_index
  drop_index.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_show_tables
  listTables.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_select_all
  select_all.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_select_count
  select_count.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_perror
  ndb_perror.cpp
  ${CMAKE_SOURCE_DIR}/storage/ndb/src/mgmapi/mgmapi_error.cpp
  ${CMAKE_SOURCE_DIR}/storage/ndb/src/kernel/error/ndbd_exit_codes.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static
  )
MYSQL_ADD_EXECUTABLE(ndb_restore
  restore/restore_main.cpp
  restore/consumer.cpp
  restore/consumer_restore.cpp
  restore/consumer_printer.cpp
  restore/Restore.cpp
  ndb_lib_move_data.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static
  )
MYSQL_ADD_EXECUTABLE(ndb_import
  ndb_import.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbtools ndbclient_static
  )

NDB_ADD_TEST(NdbImportUtil-t NdbImportUtil.cpp
  LIBS ndbtools ndbclient_static)

NDB_ADD_TEST(NdbImportCsv-t NdbImportCsv.cpp
  LIBS ndbtools ndbclient_static)

MYSQL_ADD_EXECUTABLE(ndb_config
  ndb_config.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static
  )
# Build ndbinfo_sql and run it to create ndbinfo.sql
MYSQL_ADD_EXECUTABLE(ndbinfo_sql
  ndbinfo_sql.cpp
  SKIP_INSTALL
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static
  )

ADD_CUSTOM_COMMAND(TARGET ndbinfo_sql POST_BUILD
  COMMAND $<TARGET_FILE:ndbinfo_sql>
  > ${PROJECT_BINARY_DIR}/storage/ndb/tools/ndbinfo.sql
  )

MYSQL_ADD_EXECUTABLE(ndb_index_stat
  ndb_index_stat.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndbinfo_select_all
  ndbinfo_select_all.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )
MYSQL_ADD_EXECUTABLE(ndb_blob_tool
  ndb_blob_tool.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )

MYSQL_ADD_EXECUTABLE(ndb_move_data
  ndb_move_data.cpp
  ndb_lib_move_data.cpp
  COMPONENT ClusterTools
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbclient_static ndbNDBT
  )

IF(NOT WIN32 AND NOT SOLARIS)
  IF (HAVE_NCURSESW_1 OR
      HAVE_NCURSESW_2 OR
      HAVE_NCURSESW_3 OR
      HAVE_NCURSESW_4 OR
      HAVE_NCURSESW_5)
    MESSAGE(STATUS "-- Adding ndb_top executable")
    FIND_LIBRARY(NCURSESW_LIB
      NAMES ncursesw)
    FIND_LIBRARY(NCURSESW_LIB
      NAMES ncurses)

    CHECK_LIBRARY_EXISTS("${NCURSESW_LIB}"
      stdscr "" NCURSES_HAS_STDSCR)
    IF(NOT NCURSES_HAS_STDSCR)
      FIND_LIBRARY(NCURSES_TINFO_LIB NAMES tinfo)
    ENDIF()
    MYSQL_ADD_EXECUTABLE(ndb_top
      ndb_top.cpp
      COMPONENT ClusterTools
      )
    IF(NCURSES_HAS_STDSCR)
      TARGET_LINK_LIBRARIES(ndb_top mysqlclient ${NCURSESW_LIB})
    ELSE()
      TARGET_LINK_LIBRARIES(ndb_top
        mysqlclient
        ${NCURSESW_LIB}
        ${NCURSES_TINFO_LIB})
    ENDIF()
  ELSE()
    MESSAGE(FATAL_ERROR
      "ndb_top executable could not be built, install ncursesw library")
  ENDIF()
ENDIF()

IF(NOT WIN32)
  SET(TARGET_RUNTIME_OUTPUT_DIRECTORY
    ${CMAKE_BINARY_DIR}/runtime_output_directory)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/ndb_error_reporter.pl
    ${TARGET_RUNTIME_OUTPUT_DIRECTORY}/ndb_error_reporter COPYONLY)
  EXECUTE_PROCESS(COMMAND chmod +x
    ${TARGET_RUNTIME_OUTPUT_DIRECTORY}/ndb_error_reporter)
  INSTALL_SCRIPT(${TARGET_RUNTIME_OUTPUT_DIRECTORY}/ndb_error_reporter
    DESTINATION ${INSTALL_BINDIR}
    COMPONENT ClusterTools)
ENDIF()

INSTALL(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/ndb_size.pl
  DESTINATION ${INSTALL_BINDIR}
  )

=== storage/ndb/wix/CMakeLists.txt ===
# Copyright (c) 2013, 2019, Oracle and/or its affiliates. All rights reserved.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

IF(NOT WIN32)
	# MSI building is not relvant on other platforms
	RETURN()
ENDIF()

INCLUDE(${CMAKE_SOURCE_DIR}/packaging/WiX/wix_setup.cmake)

IF(NOT WIX_DIR)
  RETURN()
ENDIF()

# This is copied from packaging/Wix. Not sure if it is possible to build the msi with something 
# other than VisualStudio. It is certainly not tested.
IF(CMAKE_GENERATOR MATCHES "Visual Studio")
 SET(CONFIG_PARAM "-DCMAKE_INSTALL_CONFIG_NAME=${CMAKE_CFG_INTDIR}")
ENDIF()

SET(SRC_SCRIPT "${CMAKE_BINARY_DIR}/packaging/WiX/create_msi.cmake")
SET(ADD_SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/write_wxs.cmake")
SET(FIXED_SCRIPT _create_msi.cmake)

SET(CMAKE_SCRIPT_SETUP COMMAND set VS_UNICODE_OUTPUT= COMMAND "${CMAKE_COMMAND}" --warn-uninitialized)

IF(WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL)
	ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/mono_off.txt"
		COMMAND "${CMAKE_COMMAND}" -E touch "${CMAKE_CURRENT_BINARY_DIR}/mono_off.txt"
		COMMENT "WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL set - just touch mono_off.txt")
ELSE(WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL)
	# Turn component-based install on.
	# Using a cmake script to do this is cumbersome and possibly not necessary, but is consitent
	# with how component-based install is turned off after the msi has been built. 
	ADD_CUSTOM_COMMAND(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/mono_off.txt"
		${CMAKE_SCRIPT_SETUP}
		"-DCACHE_ARGS=-DCPACK_MONOLITHIC_INSTALL=0"
		"-DCACHE_DIR=${CMAKE_BINARY_DIR}"		
		-P "${CMAKE_CURRENT_SOURCE_DIR}/update_cache.cmake"
		COMMAND "${CMAKE_COMMAND}" -E touch "${CMAKE_CURRENT_BINARY_DIR}/mono_off.txt"
		COMMENT "Run cmake on cache to enable component-based install (turn off CPACK_MONOLITHIC_INSTALL)"
		VERBATIM)
ENDIF(WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL)

# Copy and modify create_msi.cmake from packaging/WiX	
ADD_CUSTOM_COMMAND(OUTPUT "${FIXED_SCRIPT}"
	${CMAKE_SCRIPT_SETUP}
	"-DSRC_SCRIPT=${SRC_SCRIPT}" "-DFIXED_SCRIPT=${FIXED_SCRIPT}" "-DADD_SCRIPT=${ADD_SCRIPT}" 
	-P "${CMAKE_CURRENT_SOURCE_DIR}/fix_create_msi.cmake" 
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/fix_create_msi.cmake" 
		"${ADD_SCRIPT}" "${CMAKE_SOURCE_DIR}/packaging/WiX/create_msi.cmake.in" 
		"${CMAKE_CURRENT_BINARY_DIR}/mono_off.txt"
	COMMENT "fix_create_msi.cmake( create_msi.cmake ) -> ${FIXED_SCRIPT}"
	VERBATIM)	

SET(WXS_BASENAME mysql_cluster)

# Run modified script to create intermediate mysql_cluster.wxs.in
# Note that since CONFIGURE_FILE has builtin dependency check which prevents 
# .wxs.in from being generated if no variable has changed, we need to touch it to prevent it from
# always being considered out of date.
ADD_CUSTOM_COMMAND(OUTPUT "${WXS_BASENAME}.wxs.in"
	${CMAKE_SCRIPT_SETUP}
	"-DWXS_BASENAME=${WXS_BASENAME}"
	"${CONFIG_PARAM}"
	-P "${CMAKE_CURRENT_BINARY_DIR}/${FIXED_SCRIPT}"
	COMMAND ${CMAKE_COMMAND} -E touch "${WXS_BASENAME}.wxs.in"
 	DEPENDS "${FIXED_SCRIPT}" "${CMAKE_SOURCE_DIR}/packaging/WiX/mysql_server.wxs.in" 
	COMMENT "${FIXED_SCRIPT}( mysql_server.wxs.in ) -> ${WXS_BASENAME}.wxs.in"
	VERBATIM)

# Run ndb_create_wxs.cmake to create a wxs from intermediate wxs.in that is suitable for MySQL Cluster
ADD_CUSTOM_COMMAND(OUTPUT "${WXS_BASENAME}.wxs"
	${CMAKE_SCRIPT_SETUP}
	"-DTOPDIR=${CMAKE_CURRENT_BINARY_DIR}/testinstall" "-DWXS_BASENAME=${WXS_BASENAME}"
	"-DMAJOR_VERSION=${NDB_VERSION_MAJOR}" "-DMINOR_VERSION=${NDB_VERSION_MINOR}" "-DPATCH_VERSION=${NDB_VERSION_BUILD}" 
	-P "${CMAKE_CURRENT_SOURCE_DIR}/ndb_create_wxs.cmake"
	DEPENDS "${WXS_BASENAME}.wxs.in"
	COMMENT "ndb_create_wxs.cmake( ${WXS_BASENAME}.wxs.in ) -> ${WXS_BASENAME}.wxs"
	VERBATIM)

IF(CMAKE_SIZEOF_VOID_P EQUAL 8)
  SET(WIX_ARCH x64)
ELSE()
  SET(WIX_ARCH x86)
ENDIF()

# Run WiX-tool candle.exe on .wxs to produce WiX "object code"
ADD_CUSTOM_COMMAND(OUTPUT "${WXS_BASENAME}.wixobj"
	COMMAND "${CANDLE_EXECUTABLE}" -nologo -arch "${WIX_ARCH}" -ext WixUtilExtension "${WXS_BASENAME}.wxs" "$ENV{EXTRA_CANDLE_ARGS}"
	DEPENDS "${WXS_BASENAME}.wxs"
	COMMENT "candle( ${WXS_BASENAME}.wxs ) -> ${WXS_BASENAME}.wixobj"
	VERBATIM)

# Run WiX-tool light.exe on "object code" to produce .msi file
ADD_CUSTOM_COMMAND(OUTPUT "${CPACK_PACKAGE_FILE_NAME}.msi"
	COMMAND "${LIGHT_EXECUTABLE}" -nologo -sw1076 -ss -ext WixUIExtension -ext WixUtilExtension "${WXS_BASENAME}.wixobj" -out "${CPACK_PACKAGE_FILE_NAME}.msi" "$ENV{EXTRA_LIGHT_ARGS}"
	DEPENDS "${WXS_BASENAME}.wixobj"
	COMMENT "light( ${WXS_BASENAME}.wixobj ) -> ${CPACK_PACKAGE_FILE_NAME}.msi"
	VERBATIM)

# Set WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL=YES on the cmake command line to prevent msi building from 
# updating CPACK_MONOLITHIC_INSTALL in the CMake cache (which will regenerate project files and mess up 
# dependencies). 
# Note that as long as CPACK_MONOLITHIC_INSTALL is set in the top-level CMakeLists.txt, you must 
# manually turn CPACK_MONOLITHIC_INSTALL off in the cache 
# (by running cmake -DCPACK_MONOLITHIC_INSTALL=0 ${CMAKE_BINARY_DIR}) when using 
# WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL=YES. Merely setting CPACK_MONOLITHIC_INSTALL 
# on the command line when running cmake won't work.
# The root cause of this is cmake bug (http://public.kitware.com/Bug/view.php?id=11452) which 
# made it necessary to set CPACK_MONOLITHIC_INSTALL to get correct tars and zips when using the 
# install command with components.  
# The good thing is that the above bug has been fixed in CMake 2.8.4 so maybe these hacks can be 
# removed some day.

IF(WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL)
	ADD_CUSTOM_TARGET(NDB_MSI
		COMMAND "${CMAKE_COMMAND}" -E copy "${CPACK_PACKAGE_FILE_NAME}.msi" "${CMAKE_BINARY_DIR}/packaging/WiX/${CPACK_PACKAGE_FILE_NAME}.msi"
		DEPENDS "${CPACK_PACKAGE_FILE_NAME}.msi"
		COMMENT "Create msi for NDB"
		VERBATIM)
ELSE(WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL)
	# Turn component-based install off again.
	# Using a cmake script to do this is cumbersome, but invoking cmake -D... <cache> directly
	# doesn't work. Apparently because the parent cmake process keeps file locks which prevent the child
	# cmake process from executing properly. This does not seem to affect the custom command to turn 
	# component-based install on, maybe because that custom command does not have any dependencies?
	ADD_CUSTOM_TARGET(NDB_MSI
		${CMAKE_SCRIPT_SETUP}
		"-DCACHE_ARGS=-DCPACK_MONOLITHIC_INSTALL=1"
		"-DCACHE_DIR=${CMAKE_BINARY_DIR}"
		-P "${CMAKE_CURRENT_SOURCE_DIR}/update_cache.cmake"
		COMMAND "${CMAKE_COMMAND}" -E remove mono_off.txt
		COMMAND "${CMAKE_COMMAND}" -E copy "${CPACK_PACKAGE_FILE_NAME}.msi" "${CMAKE_BINARY_DIR}/packaging/WiX/${CPACK_PACKAGE_FILE_NAME}.msi"
		DEPENDS "${CPACK_PACKAGE_FILE_NAME}.msi"
		COMMENT "Run cmake on cache to turn CPACK_MONOLITHIC_INSTALL back on"
		VERBATIM)
ENDIF(WIX_DONT_SET_CPACK_MONOLITHIC_INSTALL)
ADD_DEPENDENCIES(NDB_MSI configure_mysql_server_extra)

=== storage/ndb/test/ndbapi/CMakeLists.txt ===
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

ADD_SUBDIRECTORY(bank)

INCLUDE(${CMAKE_SOURCE_DIR}/storage/ndb/config/type_ndbapitest.cmake)
INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/kernel
)

NDB_ADD_EXECUTABLE(create_all_tabs create_all_tabs.cpp NDBTEST)
NDB_ADD_EXECUTABLE(create_tab create_tab.cpp NDBTEST)
NDB_ADD_EXECUTABLE(drop_all_tabs drop_all_tabs.cpp NDBTEST)
NDB_ADD_EXECUTABLE(flexAsynch flexAsynch.cpp NDBTEST)
NDB_ADD_EXECUTABLE(flexBench flexBench.cpp NDBTEST)
NDB_ADD_EXECUTABLE(flexHammer flexHammer.cpp NDBTEST)
NDB_ADD_EXECUTABLE(flexTT flexTT.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testBackup testBackup.cpp)
NDB_ADD_EXECUTABLE(testBasic testBasic.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testBasicAsynch testBasicAsynch.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testBlobs testBlobs.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testDataBuffers testDataBuffers.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testDict testDict.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testIndex testIndex.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testMgm testMgm.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testNdbApi testNdbApi.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testNodeRestart testNodeRestart.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testOIBasic testOIBasic.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testOperations testOperations.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testRestartGci testRestartGci.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testScan testScan.cpp ScanFunctions.hpp NDBTEST)
NDB_ADD_EXECUTABLE(testInterpreter testInterpreter.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testScanFilter testScanFilter.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testScanInterpreter
  testScanInterpreter.cpp
  ScanFilter.hpp
  ScanInterpretTest.hpp
  NDBTEST)
NDB_ADD_EXECUTABLE(testScanPerf testScanPerf.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testSystemRestart testSystemRestart.cpp NDBTEST MYSQLCLIENT)
NDB_ADD_EXECUTABLE(testTimeout testTimeout.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testTransactions testTransactions.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testDeadlock testDeadlock.cpp NDBTEST)
NDB_ADD_EXECUTABLE(test_event test_event.cpp NDBTEST)
NDB_ADD_EXECUTABLE(ndbapi_slow_select slow_select.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testReadPerf testReadPerf.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testLcp testLcp.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testPartitioning testPartitioning.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testBitfield testBitfield.cpp NDBTEST)
NDB_ADD_EXECUTABLE(DbCreate
  bench/dbPopulate.cpp
  bench/dbPopulate.h
  bench/mainPopulate.cpp
  bench/ndb_error.hpp
  bench/ndb_schema.hpp
  bench/testData.h
  bench/testDefinitions.h
  bench/userInterface.cpp
  bench/userInterface.h
  NDBTEST)
NDB_ADD_EXECUTABLE(DbAsyncGenerator
  bench/asyncGenerator.cpp
  bench/dbGenerator.h
  bench/macros.h
  bench/mainAsyncGenerator.cpp
  bench/ndb_async2.cpp
  bench/ndb_error.hpp
  bench/ndb_schema.hpp
  bench/testData.h
  bench/testDefinitions.h
  bench/userInterface.h
  NDBTEST)
NDB_ADD_EXECUTABLE(testSRBank testSRBank.cpp)
NDB_ADD_EXECUTABLE(test_event_merge test_event_merge.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testNdbinfo testNdbinfo.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testNativeDefault testNativeDefault.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testSpj testSpj.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testLimits testLimits.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testSingleUserMode testSingleUserMode.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testIndexStat testIndexStat.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testRedo testRedo.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testDowngrade testUpgrade.cpp NDBTEST MYSQLCLIENT)
NDB_ADD_EXECUTABLE(testUpgrade testUpgrade.cpp NDBTEST MYSQLCLIENT)
NDB_ADD_EXECUTABLE(testAsynchMultiwait testAsynchMultiwait.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testDebugger testDebugger.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testFK testFK.cpp NDBTEST)
NDB_ADD_EXECUTABLE(testLoad testLoad.cpp NDBTEST)

TARGET_LINK_LIBRARIES(testBackup ndbbank ndbNDBT ndbclient_so)
TARGET_LINK_LIBRARIES(testSRBank ndbbank ndbNDBT ndbclient_so)

IF(WIN32)
  # Don't build testMgmd on Windows
ELSE()
  NDB_ADD_EXECUTABLE(testMgmd testMgmd.cpp NDBTEST)
ENDIF()

=== storage/ndb/test/run-test/CMakeLists.txt ===
# Copyright (c) 2009, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

INCLUDE_DIRECTORIES(
 ${CMAKE_SOURCE_DIR}/storage/ndb/include
 ${CMAKE_SOURCE_DIR}/storage/ndb/include/portlib
 ${CMAKE_SOURCE_DIR}/storage/ndb/include/logger
 ${CMAKE_SOURCE_DIR}/storage/ndb/include/util
 ${CMAKE_SOURCE_DIR}/storage/ndb/test/include
 ${CMAKE_SOURCE_DIR}/storage/ndb/src/ndbapi
 ${CMAKE_SOURCE_DIR}/storage/ndb/src/mgmapi
 ${CMAKE_SOURCE_DIR}/storage/ndb/src/mgmsrv
 ${CMAKE_SOURCE_DIR}/storage/ndb/src/common/mgmcommon
 ${CMAKE_SOURCE_DIR}/storage/ndb/src/mgmclient
 ${CMAKE_SOURCE_DIR}/storage/ndb/include/mgmcommon
)
IF(NOT WIN32)
  ADD_DEFINITIONS(-DDEFAULT_PREFIX=\"${CMAKE_INSTALL_PREFIX}\")
ENDIF()

MYSQL_ADD_EXECUTABLE(atrt
  main.cpp
  setup.cpp
  files.cpp
  db.cpp
  command.cpp
  test_execution_resources.cpp
  DESTINATION mysql-test/ndb
  ENABLE_EXPORTS
  LINK_LIBRARIES ndbNDBT ndbclient_static mysqlclient
  )

FILE(GLOB testcase_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} "*-tests.txt")
ADD_TEST(NAME check_testcase_files
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND atrt --check-testcase-files ${testcase_files})

ADD_CUSTOM_COMMAND(OUTPUT check_testcase_files.passed
  COMMAND atrt
          --check-testcase-files ${testcase_files}
          > ${CMAKE_CURRENT_BINARY_DIR}/check_testcase_files.output
  COMMAND echo See output in ${CMAKE_CURRENT_BINARY_DIR}/check_testcase_files.output
          > ${CMAKE_CURRENT_BINARY_DIR}/check_testcase_files.passed
          MAIN_DEPENDENCY atrt
          DEPENDS ${testcase_files}
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
          )

ADD_CUSTOM_TARGET(check_testcase_files ALL
  SOURCES check_testcase_files.passed)

INSTALL(PROGRAMS atrt-mysql-test-run
  DESTINATION bin)

INSTALL(PROGRAMS
  atrt-analyze-result.sh
  atrt-backtrace.sh
  atrt-gather-result.sh
  atrt-setup.sh
  atrt-mysqltest
  autotest-boot.sh
  autotest-run.sh
  check-tests.sh
  make-config.sh
  make-html-reports.sh
  make-index.sh
  ndb-autotest.sh
  upgrade-boot.sh
  DESTINATION mysql-test/ndb
  )

INSTALL(DIRECTORY .
  DESTINATION mysql-test/ndb
  FILES_MATCHING
  PATTERN "*-tests.txt"
  PATTERN "conf-*.cnf"
  )

=== storage/ndb/test/tools/CMakeLists.txt ===
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA


INCLUDE(${CMAKE_SOURCE_DIR}/storage/ndb/config/type_ndbapitest.cmake)

NDB_ADD_EXECUTABLE(hugoFill hugoFill.cpp NDBTEST)

NDB_ADD_EXECUTABLE(hugoLoad hugoLoad.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoLockRecords hugoLockRecords.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoPkDelete hugoPkDelete.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoPkRead hugoPkRead.cpp NDBTEST)

NDB_ADD_EXECUTABLE(hugoPkReadRecord hugoPkReadRecord.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoPkUpdate hugoPkUpdate.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoScanRead hugoScanRead.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoScanUpdate hugoScanUpdate.cpp NDBTEST)
NDB_ADD_EXECUTABLE(restart restart.cpp NDBTEST)
NDB_ADD_EXECUTABLE(verify_index verify_index.cpp NDBTEST)
NDB_ADD_EXECUTABLE(copy_tab copy_tab.cpp NDBTEST)
NDB_ADD_EXECUTABLE(create_index create_index.cpp NDBTEST)
NDB_ADD_EXECUTABLE(hugoJoin hugoJoin.cpp NDBTEST)
NDB_ADD_EXECUTABLE(ndb_connect connect.cpp NDBTEST)

NDB_ADD_EXECUTABLE(create_fk create_fk.cpp NDBTEST)
NDB_ADD_EXECUTABLE(drop_fk drop_fk.cpp NDBTEST)

NDB_ADD_EXECUTABLE(ndb_cpcc cpcc.cpp)
TARGET_LINK_LIBRARIES(ndb_cpcc ndbNDBT ndbclient_static)

IF(NOT WIN32)
  NDB_ADD_EXECUTABLE(spj_performance_test spj_performance_test.cpp
    NDBTEST MYSQLCLIENT)
ENDIF()

=== storage/ndb/memcache/extra/memcached/CMakeLists.txt ===
# Copyright (c) 2011, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA


INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/include/memcached
  ${CMAKE_CURRENT_SOURCE_DIR}/utilities
  ${CMAKE_CURRENT_SOURCE_DIR}/daemon
  )

INCLUDE_DIRECTORIES(SYSTEM ${LIBEVENT_INCLUDE_DIRS})

IF(${CMAKE_COMPILER_IS_GNUCC})
  STRING_APPEND(CMAKE_C_FLAGS " -std=gnu99")
ELSEIF(CMAKE_C_COMPILER_ID MATCHES "SunPro")
  STRING_APPEND(CMAKE_C_FLAGS " -xc99=all")
ENDIF()


# This is third-party code so we reduce the compiler warnings.
# These are numerous, so memcached cannot currently be built with -Werror.
IF(MY_COMPILER_IS_GNU_OR_CLANG)
  STRING_APPEND(CMAKE_C_FLAGS " -Wno-extra")
  STRING_APPEND(CMAKE_C_FLAGS " -Wno-declaration-after-statement")
  STRING_APPEND(CMAKE_C_FLAGS " -Wno-vla")
  STRING_APPEND(CMAKE_C_FLAGS " -Wno-error")
ENDIF()

SET(LIBMEMCACHED_UTILITIES_SOURCES
  include/memcached/config_parser.h
  include/memcached/genhash.h
  include/memcached/util.h
  utilities/config_parser.c
  utilities/engine_loader.c
  utilities/engine_loader.h
  utilities/extension_loggers.c
  utilities/genhash.c
  utilities/genhash_int.h
  utilities/util.c
  )

ADD_LIBRARY(ndb_memcached_utilities STATIC ${LIBMEMCACHED_UTILITIES_SOURCES})
IF(HAVE_LIBDL)
  TARGET_LINK_LIBRARIES(ndb_memcached_utilities dl)
ENDIF()

SET(MEMCACHED_SOURCES
  daemon/cache.h
  daemon/cache.c
  config_static.h
  daemon/daemon.c
  daemon/hash.c
  daemon/hash.h
  daemon/memcached.c
  daemon/memcached.h
  daemon/sasl_defs.h
  daemon/stats.c
  daemon/stats.h
  daemon/thread.c
  daemon/topkeys.c
  daemon/topkeys.h
  trace.h
  )

ADD_EXECUTABLE(memcached ${MEMCACHED_SOURCES})

TARGET_LINK_LIBRARIES(memcached
  ndb_memcached_utilities
  ${LIBEVENT_LIBRARIES}
  ${LIBM} ${LIBNSL} ${LIBSOCKET})
IF(HAVE_LIBDL)
  TARGET_LINK_LIBRARIES(memcached dl)
ENDIF()

IF(LIBRT)
  TARGET_LINK_LIBRARIES(memcached rt)
ENDIF()

CHECK_INCLUDE_FILE("link.h"          HAVE_LINK_H)
CHECK_INCLUDE_FILE("stdbool.h"       HAVE_STDBOOL_H)
CHECK_INCLUDE_FILE("sysexits.h"      HAVE_SYSEXITS_H)
CHECK_INCLUDE_FILE("netdb.h"         HAVE_NETDB_H)
CHECK_INCLUDE_FILE("sys/uio.h"       HAVE_SYS_UIO_H)
CHECK_INCLUDE_FILE("signal.h"        HAVE_SIGIGNORE)
CHECK_INCLUDE_FILES("sys/types.h;netinet/tcp.h" HAVE_NETINET_TCP_H)
CHECK_FUNCTION_EXISTS(htonll         HAVE_HTONLL)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/config_tests.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

INSTALL(TARGETS memcached DESTINATION ${INSTALL_SBINDIR})

=== storage/ndb/src/kernel/vm/CMakeLists.txt ===
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA


INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/storage/ndb/src/mgmapi)
INCLUDE(${CMAKE_SOURCE_DIR}/storage/ndb/config/type_kernel.cmake)

ADD_LIBRARY(ndbkernel STATIC
  ArenaPool.cpp
  Configuration.cpp
  DynArr256.cpp
  Emulator.cpp
  GlobalData.cpp
  LockQueue.cpp
  Mutex.cpp
  Ndbinfo.cpp
  NdbinfoTables.cpp
  Pool.cpp
  Rope.cpp
  SafeCounter.cpp
  SafeMutex.cpp
  SectionReader.cpp
  SegmentList.cpp
  StaticSlotPool.cpp
  TransientPagePool.cpp
  TransientSlotPool.cpp
  VMSignal.cpp
  WatchDog.cpp
  mt_thr_config.cpp
  ndbd_malloc.cpp
  ndbd_malloc_impl.cpp
)
#    WOPool.cpp
#    RWPool.cpp

ADD_LIBRARY(ndbsched STATIC
  FastScheduler.cpp
  LongSignal_nonmt.cpp
  SimplePropertiesSection_nonmt.cpp
  SimulatedBlock_nonmt.cpp
  ThreadConfig.cpp
  TimeQueue.cpp
  TransporterCallback_nonmt.cpp
  dummy_nonmt.cpp
)

IF(WITH_NDBMTD)
  ADD_LIBRARY(ndbsched_mt STATIC
    LongSignal_mt.cpp
    SimplePropertiesSection_mt.cpp
    SimulatedBlock_mt.cpp
    TransporterCallback_mt.cpp
    dummy_mt.cpp
    mt.cpp
    )
ENDIF()

ADD_LIBRARY(ndbtest STATIC
  test_context.cpp
  ../blocks/dbtup/tuppage.cpp
)

NDB_ADD_TEST(mt_thr_config-t mt_thr_config.cpp LIBS ndbgeneral)

# ${ALL_UNIT_TEST_LIBS} may be listed twice in the linker command due
# to inter-library dependencies
SET(ALL_UNIT_TEST_LIBS
  ndberror
  ndbgeneral
  ndbkernel
  ndbmgmapi
  ndbmgmcommon
  ndbportlib
  ndbsched
  ndbtest
  ndbtransport
  )

FOREACH(testprog
    CountingPool
    DynArr256
    IntrusiveList
    LHLevel
    Rope
    SegmentList
    )
  NDB_ADD_TEST("${testprog}-t" "${testprog}.cpp"
    LIBS ${ALL_UNIT_TEST_LIBS} ${ALL_UNIT_TEST_LIBS})
ENDFOREACH(testprog)

NDB_ADD_TEST(ndbd_malloc-t ndbd_malloc_impl.cpp LIBS ${ALL_UNIT_TEST_LIBS} ${ALL_UNIT_TEST_LIBS})

IF(WITH_NDBMTD)
  NDB_ADD_TEST(mt-send-t mt-send-t.cpp LIBS ${ALL_UNIT_TEST_LIBS})
ENDIF()

=== storage/ndb/src/ndbjtie/test/CMakeLists.txt ===
# Copyright (c) 2010, 2019, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

# the test classes
SET(JAVA_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/test/JTieTestBase.java
  ${CMAKE_CURRENT_SOURCE_DIR}/test/MySqlUtilsTest.java
  ${CMAKE_CURRENT_SOURCE_DIR}/test/NdbJTieConstantsTest.java
  ${CMAKE_CURRENT_SOURCE_DIR}/test/NdbJTieMultiLibTest.java
  ${CMAKE_CURRENT_SOURCE_DIR}/test/NdbJTieSmokeTest.java
  )

SET(CLASSPATH
  ${CMAKE_BINARY_DIR}/storage/ndb/src/ndbjtie/test/target/classes
  ${CMAKE_BINARY_DIR}/storage/ndb/src/ndbjtie/target/classes
  ${CMAKE_BINARY_DIR}/storage/ndb/src/ndbjtie/jtie/target/classes
  ${CMAKE_BINARY_DIR}/storage/ndb/src/ndbjtie/jtie/test/myjapi/target/classes)

CREATE_JAR(ndbjtie-test ${JAVA_SOURCES}
  CLASSPATH ${CLASSPATH}
  DEPENDENCIES ndbjtie.jar jtie.jar jtie-test-myjapi.jar)


INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/storage/ndb/src/ndbjtie/utils
  ${CMAKE_SOURCE_DIR}/storage/ndb/src/ndbjtie/jtie
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/mgmapi
  ${CMAKE_SOURCE_DIR}/storage/ndb/include/ndbapi
  ${JNI_INCLUDE_DIRS}
  )

# enable safety behaviour
STRING_APPEND(CMAKE_CXX_FLAGS " -DJTIE_OBJECT_CLEAR_ADDRESS_UPON_DELETE")

# shared library for testing
ADD_LIBRARY(libndbjtie_unit_tests SHARED
  ndbjtie_unit_tests_consts.cpp
  ndbjtie_unit_tests_lib.cpp
  )

SET_TARGET_PROPERTIES(libndbjtie_unit_tests PROPERTIES
  LINK_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS}"
  OUTPUT_NAME "ndbjtie_unit_tests")

SET_TARGET_PROPERTIES(libndbjtie_unit_tests PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/library_output_directory)

IF(WIN32)
  # This must be a cmake bug on windows ...
  # Anyways, with this the .dll ends up in the desired directory.
  SET_TARGET_PROPERTIES(libndbjtie_unit_tests PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/library_output_directory)
ENDIF()

IF(APPLE)
  SET_TARGET_PROPERTIES(libndbjtie_unit_tests PROPERTIES
    MACOSX_RPATH ON
  )
ENDIF()

#### Tests ###

SET(BIN_DIR "${CMAKE_CURRENT_BINARY_DIR}")
SET(TEST_JAR "${BIN_DIR}/ndbjtie-test-${JAVA_NDB_VERSION}.jar")

GET_FILENAME_COMPONENT(NDBJTIE_DIR "${BIN_DIR}" PATH)
SET(NDBJTIE_JAR "${NDBJTIE_DIR}/ndbjtie-${JAVA_NDB_VERSION}.jar")

GET_FILENAME_COMPONENT(NDBCLIENT_DIR "${NDBJTIE_DIR}" PATH)

SET(MYJAPI_TEST_DIR "${NDBJTIE_DIR}/jtie/test/myjapi")
SET(MYJAPI_TEST_JAR
  "${MYJAPI_TEST_DIR}/jtie-test-myjapi-${JAVA_NDB_VERSION}.jar")

SET(UNLOAD_TEST_DIR "${NDBJTIE_DIR}/jtie/test/unload")
SET(UNLOAD_TEST_JAR
  "${UNLOAD_TEST_DIR}/jtie-test-unload-${JAVA_NDB_VERSION}.jar")

IF(WITH_ASAN)
  MESSAGE(STATUS "Skipping java tests for ASAN builds")
  RETURN()
ENDIF()

ADD_TEST(
  NAME test_ndbjtie_mutils
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}"
  "test.MySqlUtilsTest"
)

ADD_TEST(
  NAME test_ndbjtie_constants
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}${JAVA_SEPERATOR}${BIN_DIR}"
  "-Dtest.NdbJTieConstantsTest.ndbjtie_jar_file=${NDBJTIE_JAR}"
  "test.NdbJTieConstantsTest"
)

ADD_TEST(
  NAME test_ndbjtie_multilib
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}${JAVA_SEPERATOR}${MYJAPI_TEST_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}${JAVA_SEPERATOR}${MYJAPI_TEST_DIR}/${JAVA_SUBDIR}${JAVA_SEPERATOR}${BIN_DIR}"
  "test.NdbJTieMultiLibTest"
)

ADD_TEST(
  NAME test_ndbjtie_smoke
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}"
  "test.NdbJTieSmokeTest"
)

SET(UNLOAD_TEST "com.mysql.jtie.test.MyLoadUnloadTest")


ADD_TEST(
  NAME test_ndbjtie_unload_mutils
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}${JAVA_SEPERATOR}${UNLOAD_TEST_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}${JAVA_SEPERATOR}${BIN_DIR}"
  "-D${UNLOAD_TEST}.target_package_prefixes=test.,com.mysql.ndbjtie."
  "-D${UNLOAD_TEST}.target_class_name=test.MySqlUtilsTest"
  "-D${UNLOAD_TEST}.target_method_name=test"
  "test.MyLoadUnloadTest"
)


ADD_TEST(
  NAME test_ndbjtie_unload_constants
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}${JAVA_SEPERATOR}${UNLOAD_TEST_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}${JAVA_SEPERATOR}${BIN_DIR}"
  "-D${UNLOAD_TEST}.target_package_prefixes=test.,com.mysql.ndbjtie."
  "-D${UNLOAD_TEST}.target_class_name=test.NdbJTieConstantsTest"
  "-D${UNLOAD_TEST}.target_method_name=test"
  "-Dtest.NdbJTieConstantsTest.ndbjtie_jar_file=${NDBJTIE_JAR}"
  "test.MyLoadUnloadTest"
)

ADD_TEST(
  NAME test_ndbjtie_unload_multilib
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}${JAVA_SEPERATOR}${UNLOAD_TEST_JAR}${JAVA_SEPERATOR}${MYJAPI_TEST_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}${JAVA_SEPERATOR}${MYJAPI_TEST_DIR}/${JAVA_SUBDIR}${JAVA_SEPERATOR}${BIN_DIR}"
  "-D${UNLOAD_TEST}.target_package_prefixes=test.,myjapi.,com.mysql.ndbjtie."
  "-D${UNLOAD_TEST}.target_class_name=test.NdbJTieMultiLibTest"
  "-D${UNLOAD_TEST}.target_method_name=test"
  "test.MyLoadUnloadTest"
)

ADD_TEST(
  NAME test_ndbjtie_unload_smoke
  COMMAND
  ${Java_JAVA_EXECUTABLE_PATH} "-ea" "-Xcheck:jni"
  "-classpath" "${TEST_JAR}${JAVA_SEPERATOR}${NDBJTIE_JAR}${JAVA_SEPERATOR}${UNLOAD_TEST_JAR}"
  "-Djava.library.path=${CMAKE_BINARY_DIR}/library_output_directory/${JAVA_SUBDIR}"
  "-D${UNLOAD_TEST}.target_package_prefixes=test.,com.mysql.ndbjtie."
  "-D${UNLOAD_TEST}.target_class_name=test.NdbJTieSmokeTest"
  "-D${UNLOAD_TEST}.target_method_name=test"
  "test.MyLoadUnloadTest"
)

## mysql-cluster-community 7.5.6

=== debian/changelog ===
mysql-cluster-community (7.5.6-1debian8) jessie; urgency=low

  [ Akhil Mohan ]
  * new upstream release
  * Added new libtest_* plugins to source/include-binaries, mysql-*-test.install
  * added new plugin to source/include-binaries, mysql-*-test.install
    libtest_framework
    libtest_services
    libtest_services_threaded
    locking_service
    test_security_context
    version_token
  * added support for MECAB in
    d/{control,rules,mysql-*-server.install,source/include-binaries}
    (Closes: #20315007)
  * added automatic setup of ssl certs in
    d/mysql-*-server.mysql.init
    d/extra/mysql-systemd-start
    (Closes: #20650118)
  * removed pkg mysql-*-bench; sqlbench will not be packaged
    (Closes: #21303289)
  * removed cleanup statement for client lib symlinks *_r in d/rules
    (Closes: #21311067)

  [ Balasubramanian Kandasamy ]
  * Added mysqlpump man page to d/mysql-*-client.install
  * Added new decompression utilities lz4_decompress and zlib_decompress
    binaries.
  * Added mysqlx plugin

  [ Lars Tangvald ]
  * Added keyring directory and plugin

 -- Balasubramanian Kandasamy <balasubramanian.kandasamy@oracle.com>  Wed, 26 Aug 2015 15:20:12 +0530

mysql-cluster-community (5.7.7-rc-3ubuntu15.04) vivid; urgency=low

  * new upstream release
  * forked packaging source from utopic to vivid
  * updated Standards-Version to 3.9.6 in d/control
  * apparmor profile updated to allow read on all files under /etc/mysql
  * added new conf files under d/extra/*.conf
  * mysql_plugin moved from client to server pkg
  * innochecksum moved from client to server pkg
  * server pkg now replaces client pkg
  * added systemd service profile and script
  * new /etc/mysql/my.cnf management scheme added for Ubuntu 15.04
    as discussed in Dec 2014 for native packaging source
  * added dh "--with systemd" for enabling systemd
  * mysql-common now conflicts with
    mysql-server-5.6, mysql-server-core-5.6
    mysql-client-5.6, mysql-client-core-5.6
  * mysql-*-server no more provides
    mysql-server-5.6, mysql-server-core-5.6
  * mysql-*-client no more provides
    mysql-client-5.6, mysql-client-core-5.6

 -- Akhil Mohan <akhil.mohan@oracle.com>  Mon, 15 Jun 2015 16:48:05 +0530

mysql-cluster-community (5.7.7-rc-2ubuntu15.04) vivid; urgency=low

  * new upstream release
  * forked packaging source from utopic to vivid

 -- Akhil Mohan <akhil.mohan@oracle.com>  Wed, 15 Apr 2015 20:27:33 +0530

mysql-cluster-community (5.7.7-rc-1ubuntu14.10) utopic; urgency=low

  * new upstream release
  * updated d/extra/my.cnf to remove option sql_mode
  * non-essential tools, files and plugins have been moved to
    mysql-cluster-community-test pkg.
    mysql-cluster-community-test now replaces mysql-cluster-community-{server,client}
    (Closes: #20546298)
    (Closes: #20636865)
  * mysql-cluster-community-test now depends on perl, python, libmysqlclient-dev
    mysql-cluster-community-server now depends on psmisc
    (Closes: #20561621)
  * mysql-*-server.{mysql.init,postinst,templates} updated to deprecate
    my_i_db and use msyqld --initialize-insecure to create system tables.
    Now if user does not provide password or it is not possible to
    receive password from user then UNIX socket authentication will be
    enabled to secure the deployment by default.
    mysql-cluster-community-server now depends on mysql-cluster-community-client
    (Closes: #20613327)

 -- Akhil Mohan <akhil.mohan@oracle.com>  Fri, 27 Feb 2015 10:01:55 +0530

mysql-cluster-community (5.7.6-m16-1ubuntu14.10) utopic; urgency=low

  * new upstream release
  * init script will now run my_i_db if data dir is not present or empty
  * forked packaging source from trusty and rebranded for utopic
  * updated d/m-c-source.install to pack *.xz packaging source archive
  * added more system resources to app armor profile
  * dh_apparmor to now run before dh_installinit in d/rules
  * libmysqlclient-dev now replaces mysql-client-{,core-}5.6
  * mysql-cluster-community-server now recommends mysql-client
  * mysql-cluster-community-server now depends on apparmor
  * d/compat incremented to 9 from 8
  * d/control updated to build depend on debhelper 9
  * added d/*.lintian-overrides and d/source/lintian-overrides
  * d/rules updated to reflect correct file permissions
  * bumped up libmysqlclient version 18 => 20
  * added new plugins to source/include-binaries
    replication_observers_example
    rewriter
    rewrite_example
  * new binary mysql_ssl_rsa_setup added to d/mysql-*-server.install
  * provisioned handling of data files directory /var/lib/mysql-files
  * cmake option to specify data dir in d/rules is now removed
    as default path in cmake layout for DEB is now /var/lib/mysql

 -- Akhil Mohan <akhil.mohan@oracle.com>  Fri, 23 Jan 2015 19:59:33 +0530

mysql-cluster-community (5.7.5-m15-1ubuntu14.04) trusty; urgency=low

  * new upstream release
  * added fakeroot as build-dep in d/control
  * added d/*.dirs for bench, dev and test pkg
  * updated d/rules to make compilation verbose
  * removed default CFLAGS, CXXFLAGS in d/rules
  * removed extra whitespaces in d/*.postrm
  * added CMake option to download boost if not available
  * removed extra file modification steps in d/rules
  * removed hotcopy, mysql_zap from d/mysql-cluster-community-server
  * removed mysql_waitpid from d/mysql-cluster-community-client
  * added patch for testsuite search paths under d/patches
  * modified cmake option for testsuite in d/rules
  * removed patch d/fix-mysql_install_db.patch
  * enabled one patch in d/patches/series
  * removed extra permissions check in d/rules when fixed in source
  * modified d/mysql-*-server.postinst to stop removing /usr/my.cnf
  * modified d/*-test.* for updated location of testsuite
  * updated d/{mysql-*-server.install,rules} to include debug plugins
  * updated d/rules to remove storage engine cmake options
  * modified data dir permission in d/*server.{pre,post}inst


=== debian/control ===
Source: mysql-cluster-community
Maintainer: MySQL Release Engineering <mysql-build@oss.oracle.com>
Section: database
Priority: optional
Standards-Version: 3.9.6
Homepage: http://www.mysql.com/
Build-Depends: debhelper (>= 9.0.0), libaio-dev[linux-any], libncurses5-dev (>= 5.0-6), perl, zlib1g-dev (>= 1:1.1.3-5), po-debconf, psmisc, bison, lsb-release, cmake, fakeroot, libnuma-dev, libmecab-dev, dh-systemd


Package: mysql-server
Architecture: any
Depends: mysql-cluster-community-server (= ${binary:Version}), ${misc:Depends}
Description: MySQL Server meta package depending on latest version
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This is a meta package that depends on the latest mysql server
 package available in the repository.

Package: mysql-cluster-community-server
Architecture: any
Pre-depends: debconf (>= 0.2.17), adduser
Depends: mysql-common (>= ${binary:Version}), mysql-client (= ${binary:Version}), perl, psmisc,
 ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-common (<< 5.7.14), mysql-cluster-community-client (<< 5.7)
Conflicts: mysql,
 mysql-server-5.0, mysql-server-core-5.0,
 mysql-server-5.1, mysql-server-core-5.1,
 mysql-server-5.5, mysql-server-core-5.5,
 mysql-server-5.6, mysql-server-core-5.6,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-cluster-commercial-server,
 mysql-community-server, mysql-commercial-server,
 mariadb-server-5.5, mariadb-server-core-5.5,
 mariadb-server-10.0, mariadb-server-core-10.0,
 mariadb-server-10.1, mariadb-server-core-10.1,
 mariadb-server-10.2, mariadb-server-core-10.2
Replaces: mysql,
 mysql-server-5.0, mysql-server-core-5.0,
 mysql-server-5.1, mysql-server-core-5.1,
 mysql-server-5.5, mysql-server-core-5.5,
 mysql-server-5.6, mysql-server-core-5.6,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-cluster-community-client (<< 5.7),
 mysql-cluster-commercial-server,
 mysql-community-server, mysql-commercial-server,
 mysql-common (<< 5.7.14)
Provides: virtual-mysql-server, virtual-mysql-server-core
Description: MySQL Server
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package includes the MySQL server binary as well as related
 utilities to run and administer a MySQL server.

Package: mysql-client
Architecture: any
Depends: mysql-cluster-community-client (= ${binary:Version}), ${misc:Depends}
Description: MySQL Client meta package depending on latest version
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This is a meta package that depends on the latest mysql client
 package available in the repository.

Package: mysql-cluster-community-client
Architecture: any
Depends: mysql-common (>= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-common (<< 5.7.17), libmysqlclient-dev (<< 5.7.14)
Conflicts: mysql,
 mysql-client-5.0, mysql-client-core-5.0,
 mysql-client-5.1, mysql-client-core-5.1,
 mysql-client-5.5, mysql-client-core-5.5,
 mysql-client-5.6, mysql-client-core-5.6,
 mysql-client-5.7, mysql-client-core-5.7,
 mysql-cluster-commercial-client,
 mysql-community-client, mysql-commercial-client,
 mariadb-client-5.5, mariadb-client-core-5.5,
 mariadb-client-10.0, mariadb-client-core-10.0,
 mariadb-client-10.1, mariadb-client-core-10.1,
 mariadb-client-10.2, mariadb-client-core-10.2
Replaces: mysql,
 mysql-client-5.0, mysql-client-core-5.0,
 mysql-client-5.1, mysql-client-core-5.1,
 mysql-client-5.5, mysql-client-core-5.5,
 mysql-client-5.6, mysql-client-core-5.6,
 mysql-client-5.7, mysql-client-core-5.7,
 mysql-cluster-commercial-client,
 mysql-community-client, mysql-commercial-client,
 mysql-common (<< 5.7.17),
 libmysqlclient-dev (<< 5.7.14)
Provides: virtual-mysql-client, virtual-mysql-client-core
Description: MySQL Client
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the standard MySQL clients and
 administration tools.

Package: libmysqlclient20
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: mysql-common (>= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Description: MySQL shared client libraries
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the shared libraries for MySQL client
 applications.

Package: mysql-common
Architecture: any
Pre-depends: debconf (>= 0.2.17), ${misc:Pre-Depends}
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: mysql, mysql-server-5.6, mysql-server-core-5.6,
 mysql-client-5.6, mysql-client-core-5.6,
 mysql-server-5.7, mysql-server-core-5.7,
 mysql-client-5.7, mysql-client-core-5.7,
 mariadb-server-5.5, percona-xtradb-cluster-common-5.5,
 mysql-common (<< 5.7.14)
Replaces: mysql, mysql-server-5.5, mysql-server-core-5.5, libmysqlclient-dev,
 mysql-server-5.6, mysql-server-core-5.6,
 mysql-server-5.7, mysql-server-core-5.7,
 mariadb-server-5.5, percona-xtradb-cluster-common-5.5,
 mysql-common (<< 5.7.14)
Provides: mysql-common
Description: MySQL Common
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains common files needed by MySQL client
 library, MySQL database server, and MySQL embedded server.

Package: libmysqlclient-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient20 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Replaces: mysql-client-5.6, mysql-client-core-5.6,
 mysql-client-5.7, mysql-client-core-5.7
Description: MySQL development headers
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the development header files necessary
 to develop MySQL client applications.

Package: libmysqld-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient-dev (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Description: MySQL embedded server library
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the MySQL server as an embedded library.

Package: mysql-testsuite
Architecture: any
Depends: mysql-cluster-community-test (= ${binary:Version}), ${misc:Depends}
Description: MySQL Testsuite meta package depending on latest version
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This is a meta package that depends on the latest mysql test
 package available in the repository.

Package: mysql-cluster-community-test
Architecture: any
Depends: mysql-cluster-community-server (= ${binary:Version}),
 mysql-cluster-community-client (= ${binary:Version}), python,
 libmysqlclient-dev, ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-cluster-community-server (<< 5.7.14),
 mysql-cluster-community-client (<< 5.7.14)
Conflicts: mysql,
 mysql-testsuite-5.0, mysql-testsuite-5.1, mysql-testsuite-5.5,
 mysql-testsuite-5.6, mysql-testsuite-5.7, mysql-cluster-commercial-test,
 mariadb-test, mariadb-test-data
Description: MySQL Test Run MTR - The MySQL testsuite
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle. This package contains the MySQL regression test suite for MySQL
 database server.

Package: mysql-cluster-community-source
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: MySQL source
 The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
 and robust SQL (Structured Query Language) database server. MySQL Server
 is intended for mission-critical, heavy-load production systems as well
 as for embedding into mass-deployed software. MySQL is a trademark of
 Oracle.


Package: mysql-cluster-community-management-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Management server
 This package contains the MySQL Cluster Management Server Daemon,
 which reads the cluster configuration file and distributes this
 information to all nodes in the cluster

Package: mysql-cluster-community-data-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Data node
 This package contains MySQL Cluster Data Node Daemon, it's the process
 that is used to handle all the data in tables using the NDB Cluster
 storage engine. It comes in two variants: ndbd and ndbmtd, the former
 is single threaded while the latter is multi-threaded.

Package: mysql-cluster-community-auto-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Data node
 This package contains MySQL Cluster Data Node Daemon, it's the process
 that is used to handle all the data in tables using the NDB Cluster
 storage engine. It comes in two variants: ndbd and ndbmtd, the former
 is single threaded while the latter is multi-threaded.

Package: ndbclient
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ndb client
 This package contains the shared libraries for MySQL MySQL NDB storage
 engine client applications.

Package: ndbclient-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ndbclient
Description: ndbclient dev package
 This package contains the development header files and libraries
 necessary to develop client applications for MySQL NDB storage engine.

Package: mysql-cluster-community-java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Java connector
 This package contains MySQL Cluster Connector for Java, which includes
 ClusterJ and ClusterJPA, a plugin for use with OpenJPA.
 .
 ClusterJ is a high level database API that is similar in style and
 concept to object-relational mapping persistence frameworks such as
 Hibernate and JPA.
 .
 ClusterJPA is an OpenJPA implementation for MySQL Cluster that
 attempts to offer the best possible performance by leveraging the
 strengths of both ClusterJ and JDBC

=== debian/rules ===
#!/usr/bin/make -f

# Copyright (c) 2015, 2017, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

%:
	dh $@

export DH_VERBOSE=1
export CFLAGS=
export CXXFLAGS=

override_dh_auto_configure:
	@echo "RULES.$@"
	cmake . \
        -DWITH_BOOST=/usr/global/share -DWITH_GMOCK=/usr/global/share \
		-DBUILD_CONFIG=mysql_release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DINSTALL_DOCDIR=share/mysql/docs \
		-DINSTALL_DOCREADMEDIR=share/mysql \
		-DINSTALL_INCLUDEDIR=include/mysql \
		-DINSTALL_INFODIR=share/mysql/docs \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DINSTALL_MANDIR=share/man \
		-DINSTALL_MYSQLSHAREDIR=share/mysql \
		-DINSTALL_MYSQLTESTDIR=lib/mysql-test \
		-DINSTALL_PLUGINDIR=lib/mysql/plugin \
		-DINSTALL_SBINDIR=sbin \
		-DINSTALL_SUPPORTFILESDIR=share/mysql \
		-DSYSCONFDIR=/etc/mysql \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DWITH_SSL=bundled \
		-DWITH_INNODB_MEMCACHED=1 \
		-DWITH_MECAB=system \
		-DWITH_NUMA=ON \
		-DCOMPILATION_COMMENT="MySQL Cluster Community Server (GPL)" \
		-DINSTALL_LAYOUT=DEB \
		-DDEB_PRODUCT=cluster-community \
		
	touch $@

override_dh_auto_build:
	@echo "RULES.$@"
	$(MAKE) -j8 VERBOSE=1
	touch $@

override_dh_auto_test:
	@echo "RULES.$@"
	touch $@

override_dh_auto_install:

	@echo "RULES.$@"
	# complete install first
	$(MAKE) install DESTDIR=debian/tmp
	# remove all redundant files
	rm debian/tmp/usr/lib/mysql-test/cmake_install.cmake
	rm debian/tmp/usr/lib/mysql-test/CTestTestfile.cmake
	rm debian/tmp/usr/lib/mysql-test/Makefile
	# add missing man pages
	install -g root -o root -m 0644 debian/extra/mysql_embedded.1 debian/tmp/usr/share/man/man1
	# add MySQL Server debug binary and library to package
	install -g root -o root -m 0755 debian/extra/server-binary debian/tmp/usr/sbin/mysqld-debug
	install -g root -o root -m 0755 debian/extra/embedded-server debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libmysqld-debug.a
	# add debug plugin libraries to package
	install -g root -o root -m 0755 -d debian/tmp/usr/lib/mysql/plugin/debug
	for file in debian/extra/*-plugin; do NEW=`echo $$file | cut -d- -f1`; mv $$file $$NEW.so; done
	install -g root -o root -m 0755 debian/extra/*.so debian/tmp/usr/lib/mysql/plugin/debug
	install -g root -o root -m 0755 debian/extra/daemon_example.ini debian/tmp/usr/lib/mysql/plugin/debug
	# Add helper functions for maintainer scripts
	install -m 0644 debian/extra/mysql-helpers debian/tmp/usr/share/mysql/
	# add apparmor profile
	
	# add systemd script
	install -m 0755 debian/extra/mysql-systemd-start debian/tmp/usr/share/mysql/
	# add directory for legal docs
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-server
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-server
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-client
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-client
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-common
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/libmysqlclient20
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/libmysqlclient-dev
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/libmysqld-dev
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-testsuite
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-test
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-source
	
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-auto-installer
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-data-node
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-java
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-management-server
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/mysql-cluster-community-memcached
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/ndbclient
	install -g root -o root -m 0755 -d debian/tmp/usr/share/doc/ndbclient-dev

	# add COPYING file to each package
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-server/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-server/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-client/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-client/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-common/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/libmysqlclient20/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/libmysqlclient-dev/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/libmysqld-dev/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-testsuite/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-test/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-source/COPYING
	
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-auto-installer/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-data-node/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-java/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-management-server/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/mysql-cluster-community-memcached/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/ndbclient/COPYING
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/COPYING debian/tmp/usr/share/doc/ndbclient-dev/COPYING

	# add README file to each package
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/mysql-server/README
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/mysql-cluster-community-server/README
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/mysql-client/README
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/mysql-cluster-community-client/README
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/mysql-common/README
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/libmysqlclient20/README
	install -g root -o root -m 0644 debian/tmp/usr/share/mysql/README debian/tmp/usr/share/doc/libmysqlclient-dev/README
